library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity encode is
	Port (
			input   :  in  std_logic_vector(7 downto 0);
		   output :  out std_logic_vector(11 downto 0)
		  );
end encode;

architecture Behavioral of encode is

begin 

	with input(3 downto 0) select
	output(5 downto 0) <=	"110100" when "0000",
									"101100" when "0001",
									"011100" when "0010",
									"110010" when "0011",
									"011010" when "0100",
									"100110" when "0101",
									"010110" when "0110",
									"001110" when "0111",
									"110001" when "1000",
									"101001" when "1001",
									"011001" when "1010",
									"100101" when "1011",
									"001101" when "1100",
									"100011" when "1101",
									"010011" when "1110",
									"001011" when others;
					
	with input(7 downto 4) select
	output(11 downto 6) <=	"110100" when "0000",
									"101100" when "0001",
									"011100" when "0010",
									"110010" when "0011",
									"011010" when "0100",
									"100110" when "0101",
									"010110" when "0110",
									"001110" when "0111",
									"110001" when "1000",
									"101001" when "1001",
									"011001" when "1010",
									"100101" when "1011",
									"001101" when "1100",
									"100011" when "1101",
									"010011" when "1110",
									"001011" when others;
					
end Behavioral;